{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "DatatourismeWebAppBundle::modal.html.twig" %}

{% block title %}Prévisualisation{% endblock %}
{% block modal_dialog_class%}modal-xl{% endblock %}
{% block modal_body_class%}p-0{% endblock %}

{% block footer %}
    <button type="button" class="btn btn-default" data-dismiss="modal">Fermer</button>
{% endblock %}

{% block body %}

    {% verbatim %}
    <div id="sparql-preview-app">
        <div class="small-box bg-warning m-b-0">
            <div class="icon-heading">
                <i class="fa fa-info-circle"></i>
            </div>
            <div class="inner">
                La prévisualisation des résultats ne contient que les <strong>10 premiers résultats</strong> de votre requête.<br>
                <span class="text-sm">Vous retrouverez l'ensemble des résultats dans le fichier mis à disposition par le flux, accessible par téléchargement manuel ou par webservice.</span>
            </div>
        </div>
        <div ng-controller="PreviewController">
            <div class="blankslate blankslate-spacious" ng-show="!data && !error">
                <h4><span class="fa fa-spinner fa-pulse"></span> Exécution de la requête...</h4>
            </div>

            <div class="blankslate blankslate-spacious" ng-show="data != null && !data.results.bindings.length">
                <h4>La requête n'a renvoyé aucun résultat.</h4>
            </div>

            <div class="blankslate blankslate-spacious text-red" ng-show="error">
                <h4><span class="fa fa-warning"></span> L'exécution de la requête a rencontré une erreur :</h4>
                <p>{{ error.message }}</p>
            </div>

            <div class="table-responsive">
                <table class="table table-hover m-b-0" ng-show="data && !error">
                    <thead>
                        <tr>
                            <th ng-repeat="var in data.head.vars">{{ var }}</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr ng-repeat="binding in data.results.bindings">
                            <td ng-repeat="key in data.head.vars" ng-init="var = binding[key]">
                                <a ng-show="var.type == 'uri'" href="{{ var.value }}" target="_blank">{{ var.value }}</a>
                                <span ng-show="var.type != 'uri'" >{{ var.value }}</span>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    {% endverbatim %}

    <script>
        var app = angular.module('sparql-preview', []);
        app.controller('PreviewController', ['$scope', '$http', function($scope, $http) {
            $scope.data = null;
            $scope.error = null;
            $http.post("{{ path('flux.editor.preview', {id: flux.id}) }}", {query: "{{ query|e('js') }}"}).then(function(response) {
                $scope.data = response.data;
            }, function(response) {
                $scope.error = response.data.error;
            })
        }]);
        angular.element(function() {
            angular.bootstrap($('#sparql-preview-app'), ['sparql-preview']);
        });
    </script>
{% endblock %}
